<?php

namespace App\Http\Controllers;

use App\Company;
use App\Expence;
use App\installment;
use App\LandPurchase;
use App\purchaseInstallment;
use App\ReferenceWithdraw;
use App\Sale;
use Carbon\Carbon;
use Illuminate\Http\Request;

class CashBookController extends Controller
{
    public function report(Request $request)
    {
        if ($request->date_range) {


            $x = 1;
            $delim = ' - ';
            $str = $request->date_range;
            $parts = explode($delim,$str);
            $string1 = implode($delim,array_slice($parts,0,$x)) . $delim;
            $string2 = implode($delim,array_slice($parts,$x));

            $string2 = date("y-m-d", strtotime($string2));
            $string1 = date("y-m-d", strtotime($string1));

            $sales = Sale::whereBetween('created_at', [$string1, $string2])->sum('paid');
            $land_installment = installment::whereBetween('created_at', [$string1, $string2])->sum('amount');

            $purchase = LandPurchase::whereBetween('created_at', [$string1, $string2])->sum('paid_amount');
            $ref_with = ReferenceWithdraw::whereBetween('created_at', [$string1, $string2])->sum('amount');
            $expence = Expence::whereBetween('created_at', [$string1, $string2])->sum('amount');
            $purchase_installment = purchaseInstallment::whereBetween('created_at', [$string1, $string2])->sum('amount');

            $total_income = $sales + $land_installment;

            $total_expense = $purchase + $ref_with + $expence + $purchase_installment;

        } else {
            $sales = Sale::whereDate('created_at', Carbon::today())->sum('paid');
            $land_installment = installment::whereDate('created_at', Carbon::today())->sum('amount');

            $purchase = LandPurchase::whereDate('created_at', Carbon::today())->sum('paid_amount');
            $ref_with = ReferenceWithdraw::whereDate('created_at', Carbon::today())->sum('amount');
            $expence = Expence::whereDate('created_at', Carbon::today())->sum('amount');
            $purchase_installment = purchaseInstallment::whereDate('created_at', Carbon::today())->sum('amount');

            $total_income = $sales + $land_installment;

            $total_expense = $purchase + $ref_with + $expence + $purchase_installment;
        }
        $company = Company::latest()->first();
        return view('report.cashbook', compact('company', 'sales', 'land_installment', 'purchase', 'purchase_installment', 'ref_with', 'expence', 'total_income', 'total_expense'));
    }
}
