<?php

namespace App\Http\Controllers;

use App\installment;
use App\LandPurchase;
use App\Member;
use App\Plot;
use App\Reference;
use App\Sale;
use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        $total_member = Member::count();
        $total_plot = Plot::count();
        $total_sales = Sale::count();
        $total_purchase = LandPurchase::count();
        $total_reference = Reference::count();
        $total_installment = installment::count();

        return view('home', compact('total_member', 'total_installment', 'total_plot', 'total_purchase', 'total_reference', 'total_sales'));
    }
}
