<?php

namespace App\Http\Controllers;

use App\CommisionPlan;
use App\Company;
use App\Events\SendSMS;
use App\installment;
use App\Member;
use App\Sale;
use App\Plot;
use App\SaleDetail;
use App\Account;
use App\ReferenceIncome;
use App\Reference;
use Brian2694\Toastr\Facades\Toastr;
use Illuminate\Http\Request;

class InstallmentController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $installments = installment::with(['sale', 'member'])->get();
        //  $sales = SaleDetail::with(['installment', 'member'])->get();
        //$sales = Sale::with('member', 'installments')->get();

        //dd($installments);
        $company = Company::latest()->first();
        return view('installment.index', compact('installments', 'company'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Request $request)
    {
        return view('installment.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'member_id' => 'required',
            'date' => 'required',
            'sales_id' => 'required',
        ]);

        $installment = new installment();


        $installment->member_id = $request->member_id;
        $installment->sales_id = $request->sales_id;
        $installment->amount = $request->amount;
        $installment->date = $request->date;
        $member = Member::where('id', $request->member_id)->first();
        $ref_id = $member->reference_id;
        $b_id = $member->block_id;
        $installment->reference_id = $ref_id;
        //dd($installment->reference_id);
        $plan = CommisionPlan::where('block_id', $b_id)->first();

        $pay = $installment->amount;
        $paid_am = $plan->installment_amount;
        // $installment->refference_log = ($pay * $paid_am) / 100;

        // $ins =  $installment->refference_log;

        // $installment->company_log = $pay - $ins;
        $installment->company_log = $pay;

        $installment->save();

        $account = account::where('reference_id', $installment->reference_id)->first();


        $pre_account = $account->company_log;

        $account->company_log = $installment->amount + $pre_account;
        // dd($account->company_log);
        $account->save();

        $sales = Sale::with(['installments'])->where('id', $installment->sales_id)->first();
        //dd($sales);

        $paid_s = installment::where('sales_id', $installment->sales_id)->sum('amount');
        // dd($paid_s);
        $company = installment::where('sales_id', $installment->sales_id)->sum('company_log');
        $refference = installment::where('sales_id', $installment->sales_id)->sum('refference_log');
        $paid_installment_count = installment::where('sales_id', $installment->sales_id)->count();
        $member = Member::where('id', $request->member_id)->first();

        $id = $member->reference_id;
        $ref = Reference::where('id', $id)->first();
        $total_paid = $sales->paid + $paid_s;
        $due  = ($sales->due_amount + $sales->paid + $sales->discount)  - $total_paid;

        $remain_installment = $sales->installment - $paid_installment_count;
        $sale = SaleDetail::with(['installments'])->where('sales_id', $request->sales_id)->first();
        $pre_paid = $sale->company_log;
        $sale->paid = $total_paid;
        $sale->due_amount = $due;
        $sale->installment = $remain_installment;
        $sale->company_log = $installment->amount + $pre_paid;
        // $sale->refference_log = $refference + $sale->refference_log;

        $sale->save();

        $plot = Plot::where('block_id', $b_id)->first();
        $ri = new ReferenceIncome();
        $ri->member_id = $member->id;
        $ri->reference_id = $ref->id;
        $ri->amount =  ($pay * $paid_am) / 100;
        $ri->member_id = $member->id;
        // $ri->paid_amount =  $sale->paid;
        $ri->installment_amount =  $sale->installment_amount;
        $ri->intall_id =  $installment->id;
        $ri->booking_amount = $sale->booking_amount;
        $ri->installment_per_amount =   $sale->install_amount;
        $ri->ekkalin_per_amount =   $sale->ekkalin_amount;


        $ri->block_id = $plan->block_id;
        $ri->block_name =   $plan->block_title;
        $ri->katha =  $plan->katha;

        $ri->plot_size =   $plot->plot_size;
        $ri->face =  $plot->face;
        $ri->road =  $plot->road;




        $ri->status =  3;
        $ri->isDelete =  0;

        //dd($ri);
        $ri->save();
        $to = $member->mobile;
        $message = "Dear " . $member->name . ", You have paid an installment of " . $installment->amount . " Tk. Number of remaining installments are " . $remain_installment . ". Total Due amount " . $due . "TK";

        event(new SendSMS($to, $message));

        Toastr::success('Installment Successfully Created :)', 'Success');
        return redirect()->route('admin.installment.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\installment  $installment
     * @return \Illuminate\Http\Response
     */
    // public function show(installment $installment)
    // {
    //     dd('dd');
    //     return view('installment.show', compact('installment'));
    // }

    public function show_installment($id)
    {

        $installment = installment::where('member_id', $id)->get();
        $member = Member::with(['sales', 'installments'])->where('id', $id)->first();
        $sales = Sale::with(['installments'])->where('member_id', $id)->first();
        $company = Company::latest()->first();
        //dd($sales);
        return view('installment.show', compact('installment', 'member', 'sales', 'company'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\installment  $installment
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $installment = installment::findOrFail($id);
        return view('installment.edit', compact('installment'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\installment  $installment
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $request->validate([
            'member_id' => 'required',
            'date' => 'required',
            'sales_id' => 'required',
        ]);

        $installment = installment::findOrFail($id);

        $installment->member_id = $request->member_id;
        $installment->sales_id = $request->sales_id;
        $installment->amount = $request->amount;
        $installment->date = $request->date;
        $member = Member::where('id', $request->member_id)->first();
        $ref_id = $member->reference_id;
        $b_id = $member->block_id;
        $installment->reference_id = $ref_id;
        //dd($installment->reference_id);
        $plan = CommisionPlan::where('block_id', $b_id)->first();

        $pay = $installment->amount;
        $paid_am = $plan->installment_amount;
        // $installment->refference_log = ($pay * $paid_am) / 100;

        // $ins =  $installment->refference_log;

        // $installment->company_log = $pay - $ins;
        $installment->company_log = $pay;

        $installment->save();

        $account = account::where('reference_id', $installment->reference_id)->first();


        $pre_account = $account->company_log;

        $account->company_log = $installment->amount + $pre_account;
        // dd($account->company_log);
        $account->save();

        $sales = Sale::with(['installments'])->where('id', $installment->sales_id)->first();
        //dd($sales);

        $paid_s = installment::where('sales_id', $installment->sales_id)->sum('amount');
        // dd($paid_s);
        $company = installment::where('sales_id', $installment->sales_id)->sum('company_log');
        $refference = installment::where('sales_id', $installment->sales_id)->sum('refference_log');
        $paid_installment_count = installment::where('sales_id', $installment->sales_id)->count();
        $member = Member::where('id', $request->member_id)->first();

        $id = $member->reference_id;
        $ref = Reference::where('id', $id)->first();
        $total_paid = $sales->paid + $paid_s;
        $due  = ($sales->due_amount + $sales->paid + $sales->discount)  - $total_paid;

        $remain_installment = $sales->installment - $paid_installment_count;
        $sale = SaleDetail::with(['installments'])->where('sales_id', $request->sales_id)->first();
        $pre_paid = $sale->company_log;
        $sale->paid = $total_paid;
        $sale->due_amount = $due;
        $sale->installment = $remain_installment;
        $sale->company_log = $installment->amount + $pre_paid;
        // $sale->refference_log = $refference + $sale->refference_log;

        $sale->save();

        $plot = Plot::where('block_id', $b_id)->first();
        $ri = new ReferenceIncome();
        $ri->member_id = $member->id;
        $ri->reference_id = $ref->id;
        $ri->amount =  ($pay * $paid_am) / 100;
        $ri->member_id = $member->id;
        // $ri->paid_amount =  $sale->paid;
        $ri->installment_amount =  $sale->installment_amount;
        $ri->intall_id =  $installment->id;
        $ri->booking_amount = $sale->booking_amount;
        $ri->installment_per_amount =   $sale->install_amount;
        $ri->ekkalin_per_amount =   $sale->ekkalin_amount;


        $ri->block_id = $plan->block_id;
        $ri->block_name =   $plan->block_title;
        $ri->katha =  $plan->katha;

        $ri->plot_size =   $plot->plot_size;
        $ri->face =  $plot->face;
        $ri->road =  $plot->road;




        $ri->status =  3;
        $ri->isDelete =  0;

        //dd($ri);
        $ri->save();


        Toastr::success('Installment Successfully Updated :)', 'Success');
        return redirect()->back();
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\installment  $installment
     * @return \Illuminate\Http\Response
     */
    public function destroy(installment $installment)
    {
        if ($installment->delete()) {
            Toastr::success('Member deleted successfully :)', 'Success');
            return redirect()->back();
        } else {
            Toastr::error('Something went wrong :(', 'Error');
            return redirect()->back();
        }
    }

    public function search(Request $request)
    {
        $member = Member::with(['sales', 'installments'])->where('serial_id', $request->member_id)->first();
        $sales = Sale::with(['installments'])->where('member_id', $request->member_id)->first();
        $sale = SaleDetail::with(['installments'])->where('member_id', $request->member_id)->first();

        $paid = installment::where('member_id', $request->member_id)->sum('amount');
        //dd($sale->paid);
        $company = installment::where('sales_id', $request->sales_id)->sum('company_log');
        $refference = installment::where('sales_id', $request->sales_id)->sum('refference_log');
        $paid_installment_count = installment::where('sales_id', $request->sales_id)->count();
        $member = Member::where('id', $request->member_id)->first();

        $total_paid = $sales->paid + $paid;
        $due  = ($sales->due_amount + $sales->paid + $sales->discount)  - $total_paid;
        // dd($total_paid);
        return view('installment.create', compact('request', 'member', 'total_paid', 'due'));
    }

    public function report(Request $request)
    {
        if ($request->date_range) {
            $x = 1;
            $delim = ' - ';
            $str = $request->date_range;
            $parts = explode($delim, $str);
            $string1 = implode($delim, array_slice($parts, 0, $x)) . $delim;
            $string2 = implode($delim, array_slice($parts, $x));

            $string2 = date("y-m-d", strtotime($string2));
            $string1 = date("y-m-d", strtotime($string1));
            $installments = installment::whereBetween('created_at', [$string1, $string2])->get();
        } else {
            $installments = installment::all();
        }
        $company = Company::latest()->first();

        return view('report.installment', compact('installments', 'company'));
    }
}
