<?php

namespace App\Http\Controllers;

use App\Events\SendSMS;
use App\installment;
use App\ReferenceWithdraw;
use App\ReferenceIncome;
use App\Account;
use App\SaleDetail;
use Brian2694\Toastr\Facades\Toastr;
use Illuminate\Http\Request;
use phpDocumentor\Reflection\DocBlock\Tags\Reference\Reference;

class ReferenceWithdrawController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $withdraws = ReferenceWithdraw::all();
        return view('withdraw.index', compact('withdraws'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Request $request)
    {
        $reference = \App\Reference::with(['referenceIncomes', 'withdraws'])->where('id', $request->reference_id)->first();
        $re_id = $request->reference_id;
        $referenceIncome = ReferenceIncome::where('reference_id', $re_id)
            ->where('isDelete', 0)
            ->get();
        $referenceIncome2 = ReferenceIncome::where('reference_id', $re_id)
            ->where('isDelete', 0)
            ->get();
        $referenceIncome3 = ReferenceIncome::where('reference_id', $re_id)
            ->where('isDelete', 0)
            ->get();

        $total_with = ReferenceWithdraw::where('reference_id', $request->reference_id)->sum('amount');
        $total_bal = \App\ReferenceIncome::where('reference_id', $request->reference_id)->sum('amount');
        return view('withdraw.create', compact('reference', 'total_with', 'total_bal', 'referenceIncome', 'referenceIncome2', 'referenceIncome3'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'amount' => 'required',
        ]);

        $wth = new ReferenceWithdraw();
        $wth->amount = $request->amount;
        $wth->reference_id = $request->reference_id;
        $wth->income_id = $request->id;

        $in = ReferenceIncome::where('id', $wth->income_id)->first();
        $total_wid = ReferenceWithdraw::where('reference_id', $request->reference_id)->sum('amount');
        $to_details =  Account::where('reference_id', $request->reference_id)->first();

        $total_paid = $to_details->company_log;
        //dd(($total_paid) -  $wth->amount);

        if (($total_paid) -  $wth->amount >= 50000) {

            if ($in->status == 2) {
                $company_am = $total_paid;
                $reff_log = ($in->booking_amount * $in->katha);
                $acnt =  Account::where('member_id', $in->member_id)->first();
                //dd($acnt);
                $pre_ref = $acnt->reference_log;
                $acnt->company_log = $total_paid - $reff_log;
                $acnt->reference_log =  $reff_log  + $pre_ref;
                // dd($acnt);
                $acnt->save();

                $wth->save();
                $in->isDelete = 1;
                $in->save();

                $sale = SaleDetail::where('sales_id', $in->sell_id)->first();
                $pre_paid = $sale->company_log;
                $sale->reference_log = ($in->booking_amount * $in->katha);
                $sale->company_log = $pre_paid - ($sale->reference_log);

                $sale->save();
            } else if ($in->status == 3) {
                $inst = installment::where('id', $in->intall_id)->first();
                $pay = $inst->amount;
                $paid_am = $in->installment_per_amount;
                $inst->refference_log = ($pay * $paid_am) / 100;
                $ins =  $inst->refference_log;
                $inst->company_log = $pay - $ins;
                $inst->save();

                $acnt =  Account::where('member_id', $in->member_id)->first();
                $pre_ref = $acnt->reference_log;
                $acnt->company_log = $total_paid - $ins;
                $acnt->reference_log = $ins + $pre_ref;
                $acnt->save();


                $wth->save();
                $in->isDelete = 1;
                $in->save();
            } else if ($in->status == 1) {
                $paid_am = $total_paid;
                $pay = $in->ekkalin_per_amount;
                $acnt =  Account::where('member_id', $in->member_id)->first();
                $pre_ref = $acnt->reference_log;

                $acnt->reference_log = (($pay * $paid_am) / 100) + $pre_ref;
                $acnt->company_log = $paid_am - ($acnt->refference_log);
                $acnt->save();

                $sale = SaleDetail::where('sales_id', $in->sell_id)->first();
                $pre_paid = $sale->company_log;
                $sale->reference_log = ($in->booking_amount * $in->katha);
                $sale->company_log = $pre_paid - ($sale->reference_log);
                $sale->save();
                $wth->save();
                $in->isDelete = 1;
                $in->save();
            }
        } else {
            Toastr::error('Not sufficient amount ! :)', 'Error');
            return redirect()->back();
        }
        $ref = \App\Reference::where('id', $request->reference_id)->first();

        $to = $ref->mobile;
        $message = "Dear" . $ref->name . ", You have withdrawn amount of " . $wth->amount . " TK";

        event(new SendSMS($to, $message));

        Toastr::success('Withdraw Created ! :)', 'Success');
        return redirect()->route('admin.withdraw.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\ReferenceWithdraw  $referenceWithdraw
     * @return \Illuminate\Http\Response
     */
    public function show(ReferenceWithdraw $referenceWithdraw)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\ReferenceWithdraw  $referenceWithdraw
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $rwth = ReferenceWithdraw::findOrFail($id);
        return view('withdraw.edit', compact('rwth'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\ReferenceWithdraw  $referenceWithdraw
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $rwth = ReferenceWithdraw::findOrFail($id);
        $rwth->amount = $request->amount;


        $rwth->save();
        Toastr::success('Withdraw Updated ! :)', 'Success');
        return redirect()->route('admin.withdraw.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\ReferenceWithdraw  $referenceWithdraw
     * @return \Illuminate\Http\Response
     */
    public function destroy(ReferenceWithdraw $referenceWithdraw)
    {
        if ($referenceWithdraw->delete()) {
            Toastr::success('Withdraw deleted successfully :)', 'Success');
            return redirect()->back();
        } else {
            Toastr::error('Something went wrong :(', 'Error');
            return redirect()->back();
        }
    }
}
