<?php

namespace App\Http\Controllers;

use App\Account;
use App\CommisionPlan;
use App\Company;
use App\Events\SendSMS;
use App\Member;
use App\Plot;
use App\Reference;
use App\ReferenceIncome;
use App\Sale;
use App\SaleDetail;
use Brian2694\Toastr\Facades\Toastr;
use Illuminate\Http\Request;

class SaleController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $sales = Sale::with('member')->get();
        $company = Company::latest()->first();
        return view('sales.index', compact('sales', 'company'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $members = Member::select('serial_id', 'name', 'id')->get();
        $plots = Plot::where('quantity', '>', 0)->get();

        return view('sales.create', compact('members', 'plots'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'member_id' => 'required',
            'plot_id' => 'required',
            'due_amount' => 'required',
            'date' => 'required',
        ]);

        $plot = Plot::where('id', $request->plot_id)->first();
        //dd($plot);
        if ($plot->quantity > 0) {

            $member = Member::where('id', $request->member_id)->first();
            $reference = Reference::where('id', $member->reference_id)->first();
            //$id = $member->reference_id;
            //$name=$member->reference_id;
            // $plan = CommisionPlan::where('refference_id', $id)->first();
            $blk_id = $plot->block_id;

            $plan = CommisionPlan::where('block_id', $blk_id)->first();
            //a($plan);

            if (!$plan) {
                Toastr::success('commision plan is Not Available ! :)', 'Error');
                return redirect()->back();
            } else {
                $sale = new Sale();
                $sale->member_id = $request->member_id;
                $sale->plot_id = $request->plot_id;
                $sale->date = $request->date;
                $sale->discount = $request->discount;
                $sale->paid = $request->paid_amount;
                $sale->due_amount = $request->due_amount;
                $sale->installment = $request->installment_number;
                $sale->installment_amount = $request->installment_amount;

                $sale->save();

                $plot->quantity = $plot->quantity - 1;
                $plot->save();

                $sale_id = $sale->id;
                if (!($sale->installment)) {
                    $member = Member::where('id', $request->member_id)->first();

                    $id = $member->reference_id;
                    //$name=$member->reference_id;

                    $blk_id = $plot->block_id;

                    $plan = CommisionPlan::where('block_id', $blk_id)->first();
                    // dd($plan);
                    $ref = Reference::where('id', $id)->first();
                    //dd($ref);
                    $name = $ref->name;
                    //dd($name);
                    $pay = $plan->ekkalin_amount;
                    $paid_am = $request->paid_amount;
                    // dd($paid_am);
                    $details = new SaleDetail();
                    $details->member_id = $request->member_id;
                    $details->plot_id = $request->plot_id;
                    $details->sales_id = $sale_id;
                    $details->refference_id = $id;
                    $details->refference_name = $name;
                    $details->date = $request->date;
                    $details->discount = $request->discount;
                    $details->paid = $request->paid_amount;
                    $details->due_amount = $request->due_amount;
                    $details->installment = $request->installment_number;
                    $details->installment_amount = $request->installment_amount;
                    // $details->refference_log = ($pay * $paid_am) / 100;
                    $details->company_log = $request->paid_amount;

                    $details->booking_amount = $plan->booking_amount;
                    $details->install_amount = $plan->installment_amount;
                    $details->ekkalin_amount = $plan->ekkalin_amount;


                    // dd($details->company_log);
                    $details->save();
                    //1= ek kalin; 2= booking,
                    $ri = new ReferenceIncome();
                    $ri->member_id = $member->id;
                    $ri->reference_id = $reference->id;
                    $ri->paid_amount =  $details->paid;
                    $ri->installment_amount =  $details->installment_amount;
                    $ri->booking_amount = $details->booking_amount;
                    $ri->installment_per_amount =   $details->install_amount;
                    $ri->ekkalin_per_amount =   $details->ekkalin_amount;
                    $ri->amount = ($pay * $paid_am) / 100;
                    $ri->sell_id =  $details->id;
                    $ri->block_id = $plan->block_id;
                    $ri->block_name =   $plan->block_title;
                    $ri->katha =  $plan->katha;

                    $ri->plot_size =   $plot->plot_size;
                    $ri->face =  $plot->face;
                    $ri->road =  $plot->road;


                    $ri->status =  1;
                    $ri->isDelete =  0;
                    // dd($ri);
                    $ri->save();
                    $account = new Account();
                    $account->reference_id = $reference->id;
                    $account->member_id =   $request->member_id;
                    $account->company_log = $details->paid;
                    // $account->reference_log = $details->refference_log;
                    $account->save();
                } else {
                    $member = Member::where('id', $request->member_id)->first();
                    $id = $member->reference_id;
                    //$plan = CommisionPlan::where('refference_id', $id)->first();
                    $blk_id = $plot->block_id;
                    // dd($request->member_id);
                    $plan = CommisionPlan::where('block_id', $blk_id)->first();
                    $ref = Reference::where('id', $id)->first();
                    $member->block_id = $blk_id;
                    $member->save();
                    $name = $ref->name;
                    $pay_book = $plan->booking_amount;
                    $pay_katha = $plan->katha;
                    $pay = $pay_book * $pay_katha;
                    $paid_am = $request->paid_amount;
                    // dd($paid_am);
                    $details = new SaleDetail();
                    $details->member_id = $request->member_id;
                    $details->plot_id = $request->plot_id;
                    $details->sales_id = $sale_id;
                    $details->refference_id = $id;
                    $details->refference_name = $name;
                    $details->date = $request->date;
                    $details->discount = $request->discount;
                    $details->paid = $request->paid_amount;
                    $details->due_amount = $request->due_amount;
                    $details->installment = $request->installment_number;
                    $details->installment_amount = $request->installment_amount;
                    // $details->refference_log = $pay;

                    // // dd($details->refference_id);
                    // $details->company_log = $paid_am - $pay;
                    $details->company_log = $request->paid_amount;

                    $details->booking_amount = $plan->booking_amount;
                    $details->install_amount = $plan->installment_amount;
                    $details->ekkalin_amount = $plan->ekkalin_amount;
                    //dd($details->company_log);

                    $details->save();
                    $ri = new ReferenceIncome();
                    $ri->member_id = $member->id;
                    $ri->reference_id = $reference->id;

                    $ri->paid_amount = $details->paid;
                    $ri->installment_amount =  $details->installment_amount;
                    $ri->booking_amount = $details->booking_amount;
                    $ri->installment_per_amount =   $details->install_amount;
                    $ri->ekkalin_per_amount =   $details->ekkalin_amount;
                    $ri->amount =  $pay;

                    $ri->block_id = $plan->block_id;
                    $ri->block_name =   $plan->block_title;
                    $ri->katha =  $plan->katha;
                    $ri->sell_id =  $details->id;
                    $ri->plot_size =   $plot->plot_size;
                    $ri->face =  $plot->face;
                    $ri->road =  $plot->road;
                    $ri->status =  2;
                    $ri->isDelete =  0;

                    //dd($ri);
                    $ri->save();
                    $account = new Account();
                    $account->member_id =   $request->member_id;
                    $account->company_log = $request->paid_amount;
                    $account->reference_id = $reference->id;
                    $account->save();
                }





                $to = $member->mobile;
                $message = "Dear " . $member->name . ", Thank For the purchase from us. You paid " . $sale->paid . "TK and Due amount " . $sale->due_amount . "TK.";


                event(new SendSMS($to, $message));

                Toastr::success('Susseccesfully sold ! :)', 'Success');
                return redirect()->route('admin.sale.show', $sale->id);
            }
        } else {
            Toastr::error('Plot Not Available ! :)', 'Error');
            return redirect()->back();
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Sale  $sale
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $sale = Sale::findOrFail($id);
        $company = Company::latest()->first();
        return view('sales.show', compact('sale', 'company'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Sale  $sale
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $sale = Sale::findOrFail($id);
        $members = Member::select('serial_id', 'name', 'id')->get();
        $plots = Plot::all();
        return view('sales.edit', compact('sale', 'members', 'plots'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Sale  $sale
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $request->validate([
            'member_id' => 'required',
            'plot_id' => 'required',
            'due_amount' => 'required',
            'date' => 'required',
        ]);
        $plot = Plot::where('id', $request->plot_id)->first();
        $member = Member::where('id', $request->member_id)->first();
        $reference = Reference::where('id', $member->reference_id)->first();
        $id_r = $member->reference_id;
        $blk_id = $plot->block_id;
        $plan = CommisionPlan::where('block_id', $blk_id)->first();
        //dd($plan);



        if (!$plan) {
            // Toastr::error('Something went wrong :(', 'Error');
            Toastr::error('commision plan is Not Available ! :)', 'Error');
            return redirect()->back();
        } else {
            $sale = Sale::findOrFail($id);
            $sale->member_id = $request->member_id;
            $sale->plot_id = $request->plot_id;
            $sale->date = $request->date;
            $sale->discount = $request->discount;
            $sale->paid = $request->paid_amount;
            $sale->due_amount = $request->due_amount;
            $sale->installment = $request->installment_number;
            $sale->installment_amount = $request->installment_amount;
            $sale->save();
            $sale_id = $sale->id;
            if (!($sale->installment)) {
                $member = Member::where('id', $request->member_id)->first();


                $id = $member->reference_id;
                //$name=$member->reference_id;

                $blk_id = $plot->block_id;

                $plan = CommisionPlan::where('block_id', $blk_id)->first();
                // dd($plan);
                $ref = Reference::where('id', $id)->first();
                //dd($ref);
                $name = $ref->name;
                //dd($name);
                $pay = $plan->ekkalin_amount;
                $paid_am = $request->paid_amount;
                // dd($paid_am);
                $details = new SaleDetail();
                $details->member_id = $request->member_id;
                $details->plot_id = $request->plot_id;
                $details->sales_id = $sale_id;
                $details->refference_id = $id;
                $details->refference_name = $name;
                $details->date = $request->date;
                $details->discount = $request->discount;
                $details->paid = $request->paid_amount;
                $details->due_amount = $request->due_amount;
                $details->installment = $request->installment_number;
                $details->installment_amount = $request->installment_amount;
                // $details->refference_log = ($pay * $paid_am) / 100;
                $details->company_log = $request->paid_amount;

                $details->booking_amount = $plan->booking_amount;
                $details->install_amount = $plan->installment_amount;
                $details->ekkalin_amount = $plan->ekkalin_amount;


                // dd($details->company_log);
                $details->save();
                //1= ek kalin; 2= booking,
                $ri = new ReferenceIncome();
                $ri->member_id = $member->id;
                $ri->reference_id = $reference->id;
                $ri->paid_amount =  $details->paid;
                $ri->installment_amount =  $details->installment_amount;
                $ri->booking_amount = $details->booking_amount;
                $ri->installment_per_amount =   $details->install_amount;
                $ri->ekkalin_per_amount =   $details->ekkalin_amount;
                $ri->amount = ($pay * $paid_am) / 100;
                $ri->sell_id =  $details->id;
                $ri->block_id = $plan->block_id;
                $ri->block_name =   $plan->block_title;
                $ri->katha =  $plan->katha;

                $ri->plot_size =   $plot->plot_size;
                $ri->face =  $plot->face;
                $ri->road =  $plot->road;


                $ri->status =  1;
                $ri->isDelete =  0;
                // dd($ri);
                $ri->save();
                $account = new Account();
                $account->reference_id = $reference->id;
                $account->member_id =   $request->member_id;
                $account->company_log = $details->paid;
                // $account->reference_log = $details->refference_log;
                $account->save();
            } else {

                $member = Member::where('id', $request->member_id)->first();
                $id = $member->reference_id;
                //$plan = CommisionPlan::where('refference_id', $id)->first();
                $blk_id = $plot->block_id;
                // dd($request->member_id);
                $plan = CommisionPlan::where('block_id', $blk_id)->first();
                $ref = Reference::where('id', $id)->first();
                $member->block_id = $blk_id;
                $member->save();
                $name = $ref->name;
                $pay_book = $plan->booking_amount;
                $pay_katha = $plan->katha;
                $pay = $pay_book * $pay_katha;
                $paid_am = $request->paid_amount;
                // dd($paid_am);
                $details = new SaleDetail();
                $details->member_id = $request->member_id;
                $details->plot_id = $request->plot_id;
                $details->sales_id = $sale_id;
                $details->refference_id = $id;
                $details->refference_name = $name;
                $details->date = $request->date;
                $details->discount = $request->discount;
                $details->paid = $request->paid_amount;
                $details->due_amount = $request->due_amount;
                $details->installment = $request->installment_number;
                $details->installment_amount = $request->installment_amount;
                // $details->refference_log = $pay;

                // // dd($details->refference_id);
                // $details->company_log = $paid_am - $pay;
                $details->company_log = $request->paid_amount;

                $details->booking_amount = $plan->booking_amount;
                $details->install_amount = $plan->installment_amount;
                $details->ekkalin_amount = $plan->ekkalin_amount;
                //dd($details->company_log);

                $details->save();
                $ri = new ReferenceIncome();
                $ri->member_id = $member->id;
                $ri->reference_id = $reference->id;

                $ri->paid_amount = $details->paid;
                $ri->installment_amount =  $details->installment_amount;
                $ri->booking_amount = $details->booking_amount;
                $ri->installment_per_amount =   $details->install_amount;
                $ri->ekkalin_per_amount =   $details->ekkalin_amount;
                $ri->amount =  $pay;

                $ri->block_id = $plan->block_id;
                $ri->block_name =   $plan->block_title;
                $ri->katha =  $plan->katha;
                $ri->sell_id =  $details->id;
                $ri->plot_size =   $plot->plot_size;
                $ri->face =  $plot->face;
                $ri->road =  $plot->road;
                $ri->status =  2;
                $ri->isDelete =  0;

                //dd($ri);
                $ri->save();
                $account = new Account();
                $account->member_id =   $request->member_id;
                $account->company_log = $request->paid_amount;
                $account->reference_id = $reference->id;
                $account->save();
            }
            Toastr::success('Sales Updated ! :)', 'Success');

            return redirect()->back();
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Sale  $sale
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $sale = Sale::findOrFail($id);
        $sale->delete();
        Toastr::success('Sales Deleted ! :)', 'Success');

        return redirect()->back();
    }

    public function report(Request $request)
    {
        if ($request->date_range) {
            $x = 1;
            $delim = ' - ';
            $str = $request->date_range;
            $parts = explode($delim, $str);
            $string1 = implode($delim, array_slice($parts, 0, $x)) . $delim;
            $string2 = implode($delim, array_slice($parts, $x));

            $string2 = date("y-m-d", strtotime($string2));
            $string1 = date("y-m-d", strtotime($string1));

            $sales = Sale::whereBetween('created_at', [$string1, $string2])->with('installments')->get();
        } else {
            $sales = Sale::with('installments')->get();
        }
        $company = Company::latest()->first();

        //        return $sales;

        return view('report.sales', compact('sales', 'company'));
    }
    public function list(Request $request)
    {
        //$sales = SaleDetail::get();
        $from = $request->get('from');
        $to = $request->get('to');
        $company = Company::latest()->first();
        $total = SaleDetail::sum('company_log');
        $total_due_amount = SaleDetail::sum('due_amount');

        $total_booking_amount = SaleDetail::sum('booking_amount');
        $total_install_amount = SaleDetail::sum('install_amount');
        $total_ekkalin_amount = SaleDetail::sum('ekkalin_amount');
        if ($from || $to) {

            $sales = SaleDetail::get()
                ->whereBetween('date', array($from, $to));
        } else {
            $sales = SaleDetail::get();
        }
        return view('sales.list', compact('sales', 'company', 'total', 'total_due_amount', 'total_booking_amount', 'total_ekkalin_amount', 'total_install_amount'));
    }
    public function show_list($id)
    {
        $sale = SaleDetail::findOrFail($id);
        $plot_id = $sale->plot_id;
        $member_id = $sale->member_id;
        $plot = Plot::where('id', $plot_id)->first();
        $company = Company::latest()->first();
        $member = Member::where('id', $member_id)->first();

        return view('sales.show_list', compact('sale', 'company', 'plot', 'member'));
    }
    public function delete_list($id)
    {

        $sales = new SaleDetail();
        $sale = $sales::find($id);

        $sale->delete();
        Toastr::success('sale details Deleted ! :)', 'Success');

        return redirect()->back();
    }
}
